/**********************************************************
 * typedefs
 **********************************************************/

#define Bit(foo) (1L << (foo))

typedef pascal short (*SEProcPtr) (EventRecord *);

typedef struct PatchGlobals {
	short			pgVersion;			/* our version number */
	SEProcPtr		pgOldSE;			/* address of old SystemEvent */
	UniversalProcPtr
					pgMySystemEventUPP,	/* SystemEvent UPP */
					pgMysDmnSelectUPP,	/* sDmn Gestalt selector UPP */
					pgMySAVRSelectUPP,	/* SAVR Gestalt selector UPP */
					pgMySAVCSelectUPP;	/* SAVC Gestalt selector UPP */
	Boolean			pgSaverOn,			/* Are we asleep? */
					pgInSleepRect,		/* Is the mouse in the sleep rect? */
					pgForceUpdates,		/* Do we need to force updates? */
					pgMustSleep,		/* Do we need to fall asleep now? */
					pgMustWake,			/* Do we need to wake up now? */
					pgMustSave;			/* Are we turned on? */
	short			pgSleepRect,		/* index number of the sleep rect */
					pgWakeRect;			/* index number of the wake rect */
	long			pgLastAction,		/* time of last user action */
					pgIdleTicks,		/* idle ticks before sleep */
					pgMinBrite;			/* How dim should we get? */
	Point			pgLastMouse;		/* point where mouse was last seen */
	Rect			pgCorners[4];		/* corners of the main screen (rects) */
} PatchGlobals, *PatchGlobalsPtr;

typedef struct PrefStructure {
	short	version;					/* our version number */
	char	sleepNowCorner,				/* sleep now corner */
			sleepNeverCorner,			/* sleep never corner */
			idleTime;					/* idle time (seconds) */
	Boolean	bounceClock,				/* show the clock? */
			saverOn;					/* screen saver on? */
	char	refreshSeconds;				/* refresh time (seconds) */
	Boolean	showIcon,					/* show the startup icon? */
			forceUpdates,				/* force updates? */
			zeroBar,					/* zero menubar? */
			eraseRectPatch,				/* patch flags... */
			eraseOvalPatch,
			eraseRgnPatch,
			drawMenuBarPatch,
			initCursorPatch;
} PrefStructure, *PrefStructurePtr, **PrefStructureHandle;